
package ethernet;

/**
 * Process an redirect the ProxyWrapper messages.
 * 
 * @author Jose Simo (c) ai2-UPV 2014
 *
 */

public class ProxyManager implements MultiPeerListener {

	private MultiPeer netPeers = null;
	
	/**
	 * Constructor. The associated MultiPeer must be provided.
	 * The newly created object registers itself as MultiPeer "Specific Listener".
	 * @param mp
	 */
	public ProxyManager(MultiPeer mp) {
		netPeers = mp;
		netPeers.addSpecificListener(Message.MessageType.PROXYWRAPPER, this);

	}
	@Override
	public void onNewConnection(Destination dest) {
		//void
	}

	@Override
	public void onMessage(Message m) {
		MessageProxyWrapper proxyMsg = (MessageProxyWrapper)m;
		Message origMsg = proxyMsg.getOriginalMessage();
		netPeers.OnMessage(origMsg);
		int[] portsList = proxyMsg.getDestPortsList();
		for (int i=0; i<portsList.length; i++) {
			IPPort destPort = new IPPort(netPeers.getLocalIPPort().getAddress(), portsList[i]);
			Destination dest = netPeers.getDestinationByIPPort(destPort);
			if (dest != null) dest.send(origMsg);
		}
	}

}
