
package test;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

import ethernet.Destination;
import ethernet.Message;
import ethernet.MessagePlain;
import ethernet.MultiPeer;
import ethernet.MultiPeerListener;

/**
 * Example of MultiPeer use.
 * @author Jose Simo (c) ai2-UPV 2014
 *
 */
public class MultiPeerTest implements MultiPeerListener {

	private String name = "";
	MultiPeerTest(String n) {		
		name = n;
	}
	
	@Override
	public void onMessage(Message m) {
		System.out.println("Sensor "+name+ ": MsgType:" + m.getType().toString() + 
				           " : Received message: "+ new String(m.getBufferPayload()));
	}
	@Override
	public void onNewConnection(Destination dest) {
		// TODO Auto-generated method stub
		
	}
	public static void main(String[] args) {		
		MultiPeer mp = new MultiPeer();
		MultiPeerTest sensor1 = new MultiPeerTest("S001");
		mp.addGeneralListener(sensor1);
		MultiPeerTest sensor2 = new MultiPeerTest("S002");
		mp.addSpecificListener(Message.MessageType.PLAIN, sensor2);
		
		BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in));
		String s = "";
		while ( s != null) {
			System.out.print(">");
			try {
				s = stdin.readLine();
			} catch (IOException e) {
				break;
			}
		    mp.send(new MessagePlain(mp.getLocalIPPort(), s.getBytes()));
		}
	}

}
