
package test;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

import dcps.Topic;
import dcps.TopicListener;
import dcps.TopicsScope;

import ethernet.Message;
import ethernet.MultiPeer;

/**
 * Example of TopicScope usage.
 * @author Jose Simo (c) ai2-UPV 2014
 */
public class TopicTest implements TopicListener {
	
	@Override
	public void onMessage(Topic t, Message m) {
		byte[] buffer = m.getBufferPayload();
		String s = new String(buffer);
		String source =  m.getSourceIPPort().toString();
		long current = util.Clock.currentMicros();
		long delay = current - m.getTimeStamp();
		System.out.println("TopicTest onMessage: " + "-- Topic:" + t.getName() + " from:"+source + "  delay:"+ delay + " -- Message: " + s);     
	}

	public static void main(String[] args) {
		TopicTest sensor = new TopicTest();
		//The default TopicScope creates a default MultiPeer
		TopicsScope ts = new TopicsScope();
		Topic t1 = ts.lookup("GPS01");
		t1.addListener(sensor);
		
		BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in));
		
		String s = "";
		while ( s != null) {
			System.out.print(">");
			try {
				s = stdin.readLine();
			} catch (IOException e) {
				break;
			}
			t1.publish(s.getBytes());
		}
	}
}
