package test;

import java.io.ByteArrayOutputStream;
import java.util.regex.Pattern;

import dcps.Topic;
import dcps.TopicsScope;
import ethernet.MultiPeer;

import jssc.SerialPort;
import jssc.SerialPortException;
import jssc.SerialPortList;

public class ComTest {

    public static void main(String[] args) {
    	
		MultiPeer multiPeer = new MultiPeer();
		TopicsScope ts = new TopicsScope(multiPeer);
		Topic t1 = ts.lookup("GPS01");
    	
        ByteArrayOutputStream os = new ByteArrayOutputStream();
        SerialPort serialPort = new SerialPort("/dev/tty.Rikaline-SPP");
        try {
            serialPort.openPort();//Open serial port
            serialPort.setParams(SerialPort.BAUDRATE_9600, 
            		             SerialPort.DATABITS_8, 
            		             SerialPort.STOPBITS_1, 
            		             SerialPort.PARITY_NONE);//Set params.
            boolean flag = true;
            while(flag){
	            byte[] buffer = serialPort.readBytes(1);//Read byte
	            os.write(buffer[0]);
	            if (buffer[0] == '\n') {
	            	//Get the message line
	            	byte[] msgBuffer = os.toByteArray();
	            	//Publish the message
	            	t1.publish(msgBuffer);
	            	//Terminal output: a preliminary parse of NMEA message
	            	String msg = new String(msgBuffer);
	            	String [] msgParts = msg.split(",");
	            	if (msgParts[0].contentEquals("$GPRMC")) {
	            		for (String part : msgParts) {
	            			System.out.println("Part: "+ part);
	            		}
	            	}
	            	//Clear the auxiliary stream
	            	os.reset();
	            }
	            
            }
            serialPort.closePort();//Close serial port
        }
        catch (SerialPortException ex) {
            System.out.println(ex);
            System.out.println("Available port names in the system:");
        	String[] portNames = SerialPortList.getPortNames("/dev/", Pattern.compile("tty."));   
            for(int i = 0; i < portNames.length; i++){
                System.out.println(portNames[i]);
            }
        }
        
    }
    
}
